// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 27 1.3.1.3 source/core/collect/iaequal.inl, collection, ioc.v400, trackPseudoLevel 
#ifndef _IAEQUAL_INL_
#define _IAEQUAL_INL_

// --------------------
// IAEqualityCollection
// --------------------

#include <ilanglvl.hpp>

// public members


template <class Element>
inline
IAEqualityCollection <Element>::
IAEqualityCollection (INotifier& notifier)
{ this->SetImpl ((Implementation*)&notifier);
}


template <class Element>
inline
IAEqualityCollection <Element>::
~IAEqualityCollection ()
{
}

template <class Element>
inline IBool
IAEqualityCollection <Element>::
contains (Element const& element) const
{ return this->ImplOf (*this).Contains (&element);
}

template <class Element>
inline IBool
IAEqualityCollection <Element>::
containsAllFrom (IACollection <Element> const& collection) const
{ return this->ImplOf (*this).
    ContainsAllFrom (IACollection <Element>::ImplOf (collection));
}

template <class Element>
inline IBool
IAEqualityCollection <Element>::
locate (Element const& element, ICursor& cursor) const
{ return this->ImplOf (*this).Locate (&element, this->CrsrImplOf (cursor));
}

template <class Element>
inline IBool
IAEqualityCollection <Element>::
locateNext (Element const& element, ICursor& cursor) const
{ return this->ImplOf (*this).LocateNext (&element, this->CrsrImplOf (cursor));
}

template <class Element>
inline IBool
IAEqualityCollection <Element>::
locateOrAdd (Element const& element)
{ return this->ImplOf (*this).LocateOrAdd (&element);
}

template <class Element>
inline IBool
IAEqualityCollection <Element>::
locateOrAdd (Element const& element, ICursor& cursor)
{ return this->ImplOf (*this).LocateOrAdd (&element, this->CrsrImplOf (cursor));
}

template <class Element>
inline INumber
IAEqualityCollection <Element>::
numberOfOccurrences (Element const& element) const
{ return this->ImplOf (*this).NumberOfOccurrences (&element);
}

template <class Element>
inline IBool
IAEqualityCollection <Element>::
remove (Element const& element)
{ return this->ImplOf (*this).Remove (&element);
}

template <class Element>
inline INumber
IAEqualityCollection <Element>::
removeAllOccurrences (Element const& element)
{ return this->ImplOf (*this).RemoveAllOccurrences (&element);
}

// protected members

template <class Element>
inline
IAEqualityCollection <Element>::
IAEqualityCollection ()
{
}

template <class Element>
inline
IAEqualityCollection <Element>::
IAEqualityCollection (IAEqualityCollection <Element> const&)
{
}

// private members

template <class Element>
inline TYPENAME IAEqualityCollection <Element>::Implementation&
IAEqualityCollection <Element>::
ImplOf (IAEqualityCollection <Element> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

#endif // _IAEQUAL_INL_
