// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 40 1.4.1.3 source/core/collect/iaks.inl, collection, ioc.v400, trackPseudoLevel  
#ifndef _IAKS_INL_
#define _IAKS_INL_

// ---
// IAKeySet
// ---

#include <ilanglvl.hpp>


template <class Element, class Key>
inline
IAKeySet <Element, Key>::
IAKeySet (INotifier& notifier)
{ this->SetImpl ((Implementation*)&notifier);
}


template <class Element, class Key>
inline
IAKeySet <Element, Key>::
~IAKeySet ()
{
}

// protected members

template <class Element, class Key>
inline
IAKeySet <Element, Key>::
IAKeySet ()
{
}

template <class Element, class Key>
inline
IAKeySet <Element, Key>::
IAKeySet (IAKeySet <Element, Key> const& collection)
: Inherited (collection)
{
}

template <class Element, class Key>
inline IBool
IAKeySet <Element, Key>::
locateNextElementWithKey (Key const& key, ICursor& cursor) const
{ return IAKeyCollection <Element, Key>::
    locateNextElementWithKey (key, cursor);
}

template <class Element, class Key>
inline INumber
IAKeySet <Element, Key>::
numberOfDifferentKeys () const
{ return IAKeyCollection <Element, Key>::numberOfDifferentKeys ();
}

template <class Element, class Key>
inline INumber
IAKeySet <Element, Key>::
numberOfElementsWithKey (Key const& key) const
{ return IAKeyCollection <Element, Key>::numberOfElementsWithKey (key);
}

template <class Element, class Key>
inline INumber
IAKeySet <Element, Key>::
removeAllElementsWithKey (Key const& key)
{ return IAKeyCollection <Element, Key>::removeAllElementsWithKey (key);
}

template <class Element, class Key>
inline IBool
IAKeySet <Element, Key>::
setToNextWithDifferentKey (ICursor& cursor) const
{ return
    IAKeyCollection <Element, Key>::setToNextWithDifferentKey (cursor);
}

// private members

template <class Element, class Key>
inline TYPENAME IAKeySet <Element, Key>::Implementation&
IAKeySet <Element, Key>::
ImplOf (IAKeySet <Element, Key> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

#endif // _IAKS_INL_
