// Revision: 20 1.4.1.3 source/dde/iddecomm.hpp, dde, ioc.v400, 981126 
#ifndef _IDDECOMM_
#define _IDDECOMM_
/*******************************************************************************
* FILE NAME: iddecomm.hpp                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   Declaration of the classes:                                                *
*     IDDE                                                                     *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   Licensed Material - Property of IBM                                        *
*   (C) Copyright IBM Corp. 1992, 1997  All Rights Reserved                    *
*                                                                              *
*******************************************************************************/
#include <ibase.hpp>

#ifdef IC_PMWIN

#include <iddepl.hpp>

#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma enum(4)
#pragma pack(push,4)

class IDDE {
public:
/*-------------------------- DDE Predefined Formats --------------------------*/
typedef const char* Format;

static Format const
  IC_IMPORTD textFormat,
  IC_IMPORTD displayTextFormat,
  IC_IMPORTD bitmapFormat,
  IC_IMPORTD displayBitmapFormat,
  IC_IMPORTD metafileFormat,
  IC_IMPORTD displayMetafileFormat,
  IC_IMPORTD metafilePictureFormat,
  IC_IMPORTD displayMetafilePictureFormat,
  IC_IMPORTD paletteFormat,
  IC_IMPORTD linkFormat,
  IC_IMPORTD sylkFormat,
#ifdef IC_PM
  IC_IMPORTD codepageTextFormat,
#endif /* IC_PM */
  IC_IMPORTD dibFormat,
  IC_IMPORTD difFormat,
  IC_IMPORTD tiffFormat,
  IC_IMPORTD oemTextFormat;

private:
/*------------------------------ Hidden Members ------------------------------*/
  IDDE ( );

}; // IDDE

#pragma pack(pop)
#pragma enum(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif

#endif /* IC_PMWIN */

#endif /* _IDDECOMM_ */
