// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 39 1.4.1.4 source/core/collect/iesdil.inl, collection, ioc.v400, 981126  
#ifndef _IESDIL_INL_
#define _IESDIL_INL_

// ---
// IGEqualitySequenceAsDilTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class ElementOps>
inline
IGEqualitySequenceAsDilTableCursor <Element, ElementOps>::
IGEqualitySequenceAsDilTableCursor
  (IGEqualitySequenceAsDilTable
    <Element, ElementOps> const& collection)
: IOrderedCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class ElementOps>
inline IGEqualitySequenceAsDilTableCursor <Element, ElementOps>&
IGEqualitySequenceAsDilTableCursor <Element, ElementOps>::
operator=
  (IGEqualitySequenceAsDilTableCursor
    <Element, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGEqualitySequenceAsDilTableCursor <Element, ElementOps>::
IGEqualitySequenceAsDilTableCursor (ICursorImpl* impl)
: IOrderedCursor <Element> (impl)
{
}






























// ---
// IGEqualitySequenceAsDilTable
// ---

// public members

template <class Element, class ElementOps>
inline
IGEqualitySequenceAsDilTable <Element, ElementOps>::
IGEqualitySequenceAsDilTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new




                Instantiation (numberOfElements));
}

template <class Element, class ElementOps>
inline
IGEqualitySequenceAsDilTable <Element, ElementOps>::
IGEqualitySequenceAsDilTable
  (IGEqualitySequenceAsDilTable
    <Element, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class ElementOps>
inline IGEqualitySequenceAsDilTable <Element, ElementOps>&
IGEqualitySequenceAsDilTable <Element, ElementOps>::
operator= (IGEqualitySequenceAsDilTable
            <Element, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class ElementOps>
inline
IGEqualitySequenceAsDilTable <Element, ElementOps>::
IGEqualitySequenceAsDilTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class ElementOps>
inline TYPENAME IGEqualitySequenceAsDilTable
 <Element, ElementOps>::Implementation&
IGEqualitySequenceAsDilTable <Element, ElementOps>::
ImplOf (IGEqualitySequenceAsDilTable
         <Element, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IEqualitySequenceAsDilTable
// ---

// public members

template <class Element>
inline
IEqualitySequenceAsDilTable <Element>::
IEqualitySequenceAsDilTable (INumber numberOfElements)
: IGEqualitySequenceAsDilTable
   <Element, IEOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IEqualitySequenceAsDilTable <Element>::
IEqualitySequenceAsDilTable (PureImplementation& impl)
: IGEqualitySequenceAsDilTable
   <Element, IEOps <Element> > (impl)
{
}


// ---
// IVGEqualitySequenceAsDilTable
// ---

// public members

template <class Element, class ElementOps>
inline
IVGEqualitySequenceAsDilTable <Element, ElementOps>::
IVGEqualitySequenceAsDilTable (INumber numberOfElements)
: IGEqualitySequenceAsDilTable
    <Element, ElementOps> (*(Implementation*) *new




                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class ElementOps>
inline
IVGEqualitySequenceAsDilTable <Element, ElementOps>::
IVGEqualitySequenceAsDilTable (PureImplementation& impl)
: IGEqualitySequenceAsDilTable
    <Element, ElementOps> (impl)
{
}

// ---
// IVEqualitySequenceAsDilTable
// ---

// public members

template <class Element>
inline
IVEqualitySequenceAsDilTable <Element>::
IVEqualitySequenceAsDilTable (INumber numberOfElements)
: IVGEqualitySequenceAsDilTable
   <Element, IEOps <Element> > (numberOfElements)
{
}

// protected members

template <class Element>
inline
IVEqualitySequenceAsDilTable <Element>::
IVEqualitySequenceAsDilTable (PureImplementation& impl)
: IVGEqualitySequenceAsDilTable
   <Element, IEOps <Element> > (impl)
{
}


#endif // _IESDIL_INL_
