// Revision: 15 1.6.1.3 source/ui/baseapp/ievent.inl, basewin, ioc.v400, trackPseudoLevel  
#ifndef _IEVENT_INL_
#define _IEVENT_INL_
/*******************************************************************************
* FILE NAME: ievent.inl                                                        *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   classes declared in ievent.hpp.                                            *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*                                                                              *
*******************************************************************************/

inline  IWindowHandle IEvent::handle() const
{ return hCl; }

inline  IWindowHandle IEvent::controlHandle() const
{ return p_controlHandle; }

inline  IEvent& IEvent::setHandle  ( const IWindowHandle& handle )
{
  hCl = handle;
  return *this;
}

inline IEvent& IEvent::setDispatchingWindow  ( IWindow* window )
{
  fdispatchingWindow = window;
  return *this;
}

inline  IEvent& IEvent::setControlHandle  ( const IWindowHandle& handle )
{
  p_controlHandle = handle;
  return *this;
}

inline unsigned long IEvent::eventId() const
{ return ulClEvtId; }

inline  IEventParameter1 IEvent::parameter1() const
{ return epCl1; }

inline IEventParameter2 IEvent::parameter2() const
{ return epCl2; }

inline IEvent& IEvent::setResult(const IEventResult& er)
{
  erCl = er;
  return *this;
}

inline IEvent& IEvent::setResult(IBool er)
{
  erCl = (IEventResult)er;
  return *this;
}

inline IEventResult IEvent::result() const
{ return erCl; }

inline IEvent& IEvent::setHandlerCursor( void* cursor)
{
  fCursor = cursor;
  return *this;
}

inline IEvent& IEvent::setHandlerList( IHandlerList* handlerList)
{
  fHandlerList = handlerList;
  return *this;
}

inline void* IEvent::handlerCursor() const
{
  return fCursor;
}

inline IHandlerList* IEvent::handlerList() const
{
  return fHandlerList;
}
#endif // _IEVENT_INL_
