// Revision: 22 1.7.1.3 source/ui/baseapp/ifiledlg.inl, views, ioc.v400, trackPseudoLevel 
#ifndef _IFILEDLG_INL_
#define _IFILEDLG_INL_
/*******************************************************************************
* FILE NAME: ifiledlg.inl                                                      *
*                                                                              *
* DESCRIPTION:                                                                 *
*   This file contains the definition of the inline functions for the          *
*   classes declared in ifiledlg.hpp.                                          *
*                                                                              *
* COPYRIGHT:                                                                   *
*   IBM Open Class Library                                                     *
*   (C) Copyright International Business Machines Corporation 1992, 1997       *
*   Licensed Material - Program-Property of IBM - All Rights Reserved.         *
*                                                                              *
*******************************************************************************/

#include <itrace.hpp>

inline IFileDialog::Settings&  IFileDialog::Settings :: setOpenDialog ( )
{
  isOpenDlg = true;
  return *this;
}

inline IFileDialog::Settings&  IFileDialog::Settings :: setSaveAsDialog ( )
{
  isOpenDlg = false;
  return *this;
}

inline IBool  IFileDialog::Settings :: isOpenDialog ( ) const
{
  return isOpenDlg;
}

inline IFileDialog::Settings&
  IFileDialog::Settings :: setPosition ( const IPoint& position )
{
  isPosSet = true;
  pos = position;
  return *this;
}

inline IBool  IFileDialog::Settings :: isPositionSet ( ) const
{
  return isPosSet;
}

inline IPoint  IFileDialog::Settings :: position ( ) const
{
  return pos;
}

inline IString  IFileDialog::Settings :: title ( ) const
{
  return titleStr;
}

inline IString  IFileDialog::Settings :: okButtonText ( ) const
{
  return OKButtonStr;
}

inline IString  IFileDialog::Settings :: fileName ( ) const
{
  return fileNameStr;
}

#ifndef IC_MOTIF_FLAGNOP
inline IString  IFileDialog::Settings :: initialDrive ( ) const
{
  ITRACE_MOTIF_NOP();

  return initialDriveStr;
}
#endif

#ifndef IC_MOTIFWIN_FLAGNOP
inline IString  IFileDialog::Settings :: initialFileType ( ) const
{
  ITRACE_MOTIF_NOP();
  ITRACE_WIN_NOP();

  return initialFileTypeStr;
}
#endif

#ifndef IC_WIN
inline void IFileDialog::setDefaultStyle( const IFileDialog::Style &style )
{
  currentDefaultStyle = style;
}
#endif
#endif // _IFILEDLG_INL_
