// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 17 1.6.1.5 source/core/collect/iicbag.h, collection, ioc.v400, trackPseudoLevel 
#ifndef _IICBAG_
#define _IICBAG_

#include <ilanglvl.hpp>
#include <iiabag.h>










#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)


#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class CInherited>
class ICBagImpl : public CInherited {
public:

  typedef TYPENAME CInherited::Ops Ops;

           ICBagImpl
                            (Ops&, INumber);

           ICBagImpl
                            (Ops&, ICBagImpl
                                    <CInherited> const&);

  IBool     Add              (void const*, ICursorImpl&);

  void     AddAllFrom       (IACollectionImpl const&);

  void*    Any              () const;

  void*    ElementAt        (ICursorImpl const&) const;

  IBool     Locate           (void const*, ICursorImpl&) const;

  IBool     LocateNext       (void const*, ICursorImpl&) const;

  IBool     LocateOrAdd      (void const*, ICursorImpl&);

  void     RemoveAt         (ICursorImpl&);

  void     ReplaceAt        (ICursorImpl const& cursor,
                             void const*);

  IBool     SetToFirst       (ICursorImpl&) const;

  IBool     SetToNext        (ICursorImpl&) const;

  IBool     SetToNextDifferentElement
                            (ICursorImpl&) const;

protected:

private:












};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif








#if ! defined (__TEMPINC__)
#include <iicbag.c>
#endif



#pragma info (restore)


#endif // _IICBAG_
