// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 19 1.6.1.5 source/core/collect/iices.h, collection, ioc.v400, trackPseudoLevel 
#ifndef _IICES_
#define _IICES_

#include <ilanglvl.hpp>
#include <iiaes.h>










#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)


#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class CInherited>
class ICEqualitySequenceImpl : public CInherited {
public:

  typedef TYPENAME CInherited::Ops Ops;

           ICEqualitySequenceImpl
                            (Ops&, INumber);

           ICEqualitySequenceImpl
                            (Ops&, ICEqualitySequenceImpl
                                    <CInherited> const&);

  IBool     Add              (void const*, ICursorImpl&);

  void     AddAllFrom       (IACollectionImpl const&);

  void     AddAsFirst       (void const*, ICursorImpl&);

  void     AddAsLast        (void const*, ICursorImpl&);

  void     AddAsNext        (void const*, ICursorImpl&);

  void     AddAsPrevious    (void const*, ICursorImpl&);

  void     AddAtPosition    (IPosition, void const*, ICursorImpl&);

  void*    Any              () const;

  void*    ElementAt        (ICursorImpl const&) const;

  void*    ElementAtPosition
                            (IPosition) const;

  void*    First            () const;

  IBool     IsFirstAt        (ICursorImpl const&) const;

  IBool     IsLastAt         (ICursorImpl const&) const;

  void*    Last             () const;

  IBool     Locate           (void const*, ICursorImpl&) const;

  IBool     LocateFirst      (void const*, ICursorImpl&) const;

  IBool     LocateLast       (void const*, ICursorImpl&) const;

  IBool     LocateNext       (void const*, ICursorImpl&) const;

  IBool     LocateOrAdd      (void const*, ICursorImpl&);

  IBool     LocatePrevious   (void const*, ICursorImpl&) const;

  IPosition
           PositionAt       (ICursorImpl const&) const;

  void     RemoveAt         (ICursorImpl&);

  void     RemoveAtPosition (IPosition);

  void     RemoveFirst      ();

  void     RemoveLast       ();

  void     ReplaceAt        (ICursorImpl const& cursor,
                             void const*);

  void     ReplaceAtPosition
                            (IPosition, void const*);

  IBool     SetToFirst       (ICursorImpl&) const;

  IBool     SetToLast        (ICursorImpl&) const;

  IBool     SetToNext        (ICursorImpl&) const;

  void     SetToPosition    (IPosition, ICursorImpl&) const;

  IBool     SetToPrevious    (ICursorImpl&) const;

protected:

private:












};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif








#if ! defined (__TEMPINC__)
#include <iices.c>
#endif



#pragma info (restore)


#endif // _IICES_
