// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 48 1.5.1.3 source/core/collect/iiesdil.c, collection, ioc.v400, trackPseudoLevel 
#ifndef _IIESDIL_C_
#define _IIESDIL_C_


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)


// ---
// IEqualitySequenceAsDilTableOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
IEqualitySequenceAsDilTableOps <Element, ElementOps, Implementation>::
IEqualitySequenceAsDilTableOps (INumber numberOfElements)
: ivElementOps (),
  ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
IEqualitySequenceAsDilTableOps <Element, ElementOps, Implementation>::
IEqualitySequenceAsDilTableOps (INumber numberOfElements, void* opsArg)
: ivElementOps (opsArg),
  ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
IEqualitySequenceAsDilTableOps <Element, ElementOps, Implementation>::
IEqualitySequenceAsDilTableOps
  (IEqualitySequenceAsDilTableOps
    <Element, ElementOps, Implementation> const& collection)
: ivElementOps (collection.ivElementOps),
  ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
IEqualitySequenceAsDilTableOps <Element, ElementOps, Implementation>::
~IEqualitySequenceAsDilTableOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
IEqualitySequenceAsDilTableOps
 <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
IBool
IEqualitySequenceAsDilTableOps
 <Element, ElementOps, Implementation>::
EqualElements (void const* element1, void const* element2) const
{ return ivElementOps.Equal (*(Element const*)element1,
                             *(Element const*)element2);
}

template <class Element, class ElementOps, class Implementation>
IEqualitySequenceAsDilTableOps
 <Element, ElementOps, Implementation>::
operator ISequenceAsDilTableImpl& ()
{ return *(ISequenceAsDilTableImpl*)ivBase;
}

template <class Element, class ElementOps, class Implementation>
IEqualitySequenceAsDilTableOps
 <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl;
}


#pragma info (restore)


#endif // _IIESDIL_C_
