// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 63 1.4.1.2 source/core/collect/iihpdil.c, collection, ioc.v400, 981126 
#ifndef _IIHPDIL_C_
#define _IIHPDIL_C_


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)


// ---
// IHeapAsDilTableOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
IHeapAsDilTableOps <Element, ElementOps, Implementation>::
IHeapAsDilTableOps (INumber numberOfElements)
: ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
IHeapAsDilTableOps <Element, ElementOps, Implementation>::
IHeapAsDilTableOps (INumber numberOfElements, void* opsArg)
: ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
IHeapAsDilTableOps <Element, ElementOps, Implementation>::
IHeapAsDilTableOps
  (IHeapAsDilTableOps
    <Element, ElementOps, Implementation> const& collection)
: ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
IHeapAsDilTableOps <Element, ElementOps, Implementation>::
~IHeapAsDilTableOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
IHeapAsDilTableOps <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
IHeapAsDilTableOps <Element, ElementOps, Implementation>::
operator ISequenceAsDilTableImpl& ()
{ return *(ISequenceAsDilTableImpl*)ivBase;
}

template <class Element, class ElementOps, class Implementation>
IHeapAsDilTableOps <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl;
}


#pragma info (restore)


#endif // _IIHPDIL_C_
