// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 83 1.6.1.4 source/core/collect/iikbksb.h, collection, ioc.v400, trackPseudoLevel 
#ifndef _IIKBKSB_
#define _IIKBKSB_

#include <ilanglvl.hpp>
#include <iiakb.h>







#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)










#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

template <class Base>
class IKeyBagOnKeySortedBagMngCursorImpl;

template <class Base>
class IKeyBagOnKeySortedBagImpl;

#pragma pack(push,4)
#pragma enum(4)

template <class Base>
class IC_EXPORTC IKeyBagOnKeySortedBagMngCursorImpl : public Base::MngCursor 
{
  typedef TYPENAME Base::MngCursor Inherited;

public:

           IKeyBagOnKeySortedBagMngCursorImpl
                            (IKeyBagOnKeySortedBagImpl <Base> const&);

          ~IKeyBagOnKeySortedBagMngCursorImpl
                            ();

protected:

private:









};

template <class Base>
class IBagOnKeyBagImpl;

template <class Base>
class IAKeyBagOnKeySortedBagOps;

template <class Base>
class IC_EXPORTC IKeyBagOnKeySortedBagImpl : public IAKeyBagImpl {

  typedef  IAKeyBagImpl Inherited;

  typedef  IKeyBagOnKeySortedBagImpl <Base> Self;

public:

  typedef  IAKeyBagOnKeySortedBagOps <Base> Ops;

  typedef TYPENAME Base::Cursor Cursor;

  typedef  IKeyBagOnKeySortedBagMngCursorImpl <Base> MngCursor;

           IKeyBagOnKeySortedBagImpl
                            (Ops&, INumber);

           IKeyBagOnKeySortedBagImpl
                            (Ops&,
                             IKeyBagOnKeySortedBagImpl <Base> const&);

          ~IKeyBagOnKeySortedBagImpl
                            ();

  IBool Add              (void const*, ICursorImpl&);

  void     AddAllFrom       (IACollectionImpl const&);

  IBool AddOrReplaceElementWithKey
                            (void const*, ICursorImpl&);

  IBool AllElementsDo    (IApplFunc, void*);

  void*    Any              () const;

  IBool CheckCursor      (ICursorImpl const&) const;

  IBool CheckReplacement (ICursorImpl const&, void const* ) const;

  char const*
           ClassName        () const;

  IACollectionImpl*
           Clone            () const;

  IBool ContainsAllKeysFrom
                            (IACollectionImpl const&) const;

  IBool ContainsElementWithKey
                            (void const*) const;

  void     Copy             (IACollectionImpl const&);

  Cursor*  CreateCursor     () const;

  MngCursor*
           CreateMngCursor  () const;

  void*    ElementAt        (ICursorImpl const&) const;

  void*    ElementWithKey   (void const*) const;

  IBool IsBounded        () const;

  IBool IsConsistent     () const;

  IBool IsEmpty          () const;

  IBool IsFull           () const;

  void*    Key              (void const*) const;

  IBool LocateElementWithKey
                            (void const*, ICursorImpl&) const;

  IBool LocateNextElementWithKey
                            (void const*, ICursorImpl&) const;

  IBool LocateOrAddElementWithKey
                            (void const*, ICursorImpl&);

  INumber  NumberOfDifferentKeys
                            () const;

  INumber  NumberOfElements () const;

  INumber  NumberOfElementsWithKey
                            (void const*) const;

  INumber  RemoveAll        ();

  INumber  RemoveAll        (IPredFunc, void*);

  INumber  RemoveAllElementsWithKey
                            (void const*);

  void     RemoveAt         (ICursorImpl&);

  IBool RemoveElementWithKey
                            (void const*);

  void     ReplaceAt        (ICursorImpl const&, void const*);

  IBool ReplaceElementWithKey
                            (void const*, ICursorImpl&);

  IBool SetToFirst       (ICursorImpl&) const;

  IBool SetToNext        (ICursorImpl&) const;

  IBool SetToNextWithDifferentKey
                            (ICursorImpl&) const;

  void     operator=        (IKeyBagOnKeySortedBagImpl <Base> const&);

protected:

  IBool EqualKeys        (void const*, void const*, IArgType) const;

private:

  static
  char const*
           cvClassName;

  Base&    ivBase;

  static
  Base&    BaseOf           (IKeyBagOnKeySortedBagImpl <Base> const&);

  static
  Ops&     OpsOf            (IKeyBagOnKeySortedBagImpl <Base> const&);

  friend
  class    IKeyBagOnKeySortedBagMngCursorImpl <Base>;

  friend
  class    IKeyBagOnKeySortedBagImpl <Base>;

  friend
  class    IBagOnKeyBagImpl <Self>;

#if ! defined (__INO_STREAMING__)
public:
  IStreamerPtr&
           StreamerOf       (IACollectionImpl const&);

  void     StreamIn         (IDataStream&);

  void     StreamOut        (IDataStream&) const;

  void     AdoptStreamer    (IACollectionStreamer*);
#endif





















};

template <class Base>
class IC_EXPORTC IAKeyBagOnKeySortedBagOps {
public:

  virtual ~IAKeyBagOnKeySortedBagOps
                            ();

  virtual
  IACollectionImpl*
           Clone            () const = 0;

  virtual  operator Base&   () = 0;

protected:

private:








};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif





#include <iikbksb.inl>


#pragma info (restore)


#endif // _IIKBKSB_
