// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 95 1.4.1.2 source/core/collect/iisblst.c, collection, ioc.v400, 981126 
#ifndef _IISBLST_C_
#define _IISBLST_C_


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)


// ---
// ISortedBagAsListOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
ISortedBagAsListOps <Element, ElementOps, Implementation>::
ISortedBagAsListOps (INumber numberOfElements)
: Inherited (__isDTSClass (Element)),
  ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedBagAsListOps <Element, ElementOps, Implementation>::
ISortedBagAsListOps (INumber numberOfElements, void* opsArg)
: Inherited (__isDTSClass (Element)),
  ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedBagAsListOps <Element, ElementOps, Implementation>::
ISortedBagAsListOps
  (ISortedBagAsListOps
    <Element, ElementOps, Implementation> const& collection)
: Inherited (__isDTSClass (Element)),
  ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedBagAsListOps <Element, ElementOps, Implementation>::
~ISortedBagAsListOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
ISortedBagAsListOps <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
ISortedBagAsListOps <Element, ElementOps, Implementation>::
operator IKeySortedBagAsListImpl& ()
{ return *(IKeySortedBagAsListImpl*)ivBase;
}

template <class Element, class ElementOps, class Implementation>
ISortedBagAsListOps <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl;
}


#pragma info (restore)


#endif // _IISBLST_C_
