// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 49 1.5.1.3 source/core/collect/iismtab.c, collection, ioc.v400, trackPseudoLevel 
#ifndef _IISMTAB_C_
#define _IISMTAB_C_


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)


// ---
// ISortedMapAsTableOps
// ---

// public members

template <class Element, class Key,
          class ElementOps, class Implementation>
ISortedMapAsTableOps <Element, Key, ElementOps, Implementation>::
ISortedMapAsTableOps (INumber numberOfElements)
: ivElementOps (),
  ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
ISortedMapAsTableOps <Element, Key, ElementOps, Implementation>::
ISortedMapAsTableOps (INumber numberOfElements, void* opsArg)
: ivElementOps (opsArg),
  ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
ISortedMapAsTableOps <Element, Key, ElementOps, Implementation>::
ISortedMapAsTableOps
  (ISortedMapAsTableOps
    <Element, Key, ElementOps, Implementation> const& collection)
: ivElementOps (collection.ivElementOps),
  ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
ISortedMapAsTableOps <Element, Key, ElementOps, Implementation>::
~ISortedMapAsTableOps ()
{
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IACollectionImpl*
ISortedMapAsTableOps <Element, Key, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class Key,
          class ElementOps, class Implementation>
IBool
ISortedMapAsTableOps <Element, Key, ElementOps, Implementation>::
EqualElements (void const* element1, void const* element2) const
{ return ivElementOps.Equal (*(Element const*)element1,
                             *(Element const*)element2);
}

template <class Element, class Key,
          class ElementOps, class Implementation>
ISortedMapAsTableOps <Element, Key, ElementOps, Implementation>::
operator IKeySortedSetAsTableImpl& ()
{ return *(IKeySortedSetAsTableImpl*) ivBase;
}

template <class Element, class Key,
          class ElementOps, class Implementation>
ISortedMapAsTableOps <Element, Key, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl;
}


#pragma info (restore)


#endif // _IISMTAB_C_
