// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 56 1.6.1.4 source/core/collect/iisrksb.h, collection, ioc.v400, trackPseudoLevel 
#ifndef _IISRKSB_
#define _IISRKSB_

#include <ilanglvl.hpp>
#include <iiasr.h>







#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)










#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

template <class Base>
class ISortedRelationOnKeySortedBagMngCursorImpl;

template <class Base>
class ISortedRelationOnKeySortedBagImpl;

#pragma pack(push,4)
#pragma enum(4)

template <class Base>
class IC_EXPORTC ISortedRelationOnKeySortedBagMngCursorImpl :
  public Base::MngCursor {

  typedef TYPENAME Base::MngCursor Inherited;

public:

           ISortedRelationOnKeySortedBagMngCursorImpl
                            (ISortedRelationOnKeySortedBagImpl
                              <Base> const&);

          ~ISortedRelationOnKeySortedBagMngCursorImpl
                            ();

protected:

private:










};

template <class Base>
class IASortedRelationOnKeySortedBagOps;

template <class Base>
class IC_EXPORTC ISortedRelationOnKeySortedBagImpl :
  public IASortedRelationImpl {

  typedef  IASortedRelationImpl Inherited;

  typedef  ISortedRelationOnKeySortedBagImpl <Base> Self;

public:

  typedef  IASortedRelationOnKeySortedBagOps <Base> Ops;

  typedef TYPENAME Base::Cursor Cursor;

  typedef  ISortedRelationOnKeySortedBagMngCursorImpl <Base> MngCursor;

           ISortedRelationOnKeySortedBagImpl
                            (Ops&, INumber);

           ISortedRelationOnKeySortedBagImpl
                            (Ops&,
                             ISortedRelationOnKeySortedBagImpl
                              <Base> const&);

          ~ISortedRelationOnKeySortedBagImpl
                            ();

  IBool Add              (void const*, ICursorImpl&);

  IBool AddOrReplaceElementWithKey
                            (void const*, ICursorImpl&);

  IBool AllElementsDo    (IApplFunc, void*);

  void*    Any              () const;

  IBool CheckCursor      (ICursorImpl const&) const;

  IBool CheckReplacement (ICursorImpl const&, void const*) const;

  char const*
           ClassName        () const;

  IACollectionImpl*
           Clone            () const;

  IBool Contains         (void const*) const;

  IBool ContainsAllKeysFrom
                            (IACollectionImpl const&) const;

  IBool ContainsElementWithKey
                            (void const*) const;

  void     Copy             (IACollectionImpl const&);

  Cursor*  CreateCursor     () const;

  MngCursor*
           CreateMngCursor  () const;

  void*    ElementAt        (ICursorImpl const&) const;

  void*    ElementAtPosition
                            (IPosition) const;

  void*    ElementWithKey   (void const*) const;

  void*    First            () const;

  IBool IsBounded        () const;

  IBool IsConsistent     () const;

  IBool IsEmpty          () const;

  IBool IsFirstAt        (ICursorImpl const&) const;

  IBool IsFull           () const;

  IBool IsLastAt         (ICursorImpl const&) const;

  void*    Key              (void const*) const;

  void*    Last             () const;

  IBool Locate           (void const*, ICursorImpl&) const;

  IBool LocateElementWithKey
                            (void const*, ICursorImpl&) const;

  IBool LocateNext       (void const*, ICursorImpl&) const;

  IBool LocateNextElementWithKey
                            (void const*, ICursorImpl&) const;

  IBool LocateOrAdd      (void const*, ICursorImpl&);

  IBool LocateOrAddElementWithKey
                            (void const*, ICursorImpl&);

  INumber  NumberOfDifferentKeys
                            () const;

  INumber  NumberOfElements () const;

  INumber  NumberOfElementsWithKey
                            (void const*) const;

  IPosition
           PositionAt       (ICursorImpl const&) const;

  IBool Remove           (void const*);

  INumber  RemoveAll        ();

  INumber  RemoveAll        (IPredFunc, void*);

  INumber  RemoveAllElementsWithKey
                            (void const*);

  void     RemoveAt         (ICursorImpl&);

  void     RemoveAtPosition (IPosition);

  IBool RemoveElementWithKey
                            (void const*);

  void     RemoveFirst      ();

  void     RemoveLast       ();

  void     ReplaceAt        (ICursorImpl const&, void const*);

  void     ReplaceAtPosition
                            (IPosition, void const*);

  IBool ReplaceElementWithKey
                            (void const*, ICursorImpl&);

  IBool SetToFirst       (ICursorImpl&) const;

  IBool SetToLast        (ICursorImpl&) const;

  IBool SetToNext        (ICursorImpl&) const;

  IBool SetToNextWithDifferentKey
                            (ICursorImpl&) const;

  void     SetToPosition    (IPosition, ICursorImpl&) const;

  IBool SetToPrevious    (ICursorImpl&) const;

  void     operator=        (ISortedRelationOnKeySortedBagImpl
                              <Base> const&);

  IBool operator==       (IASortedRelationImpl const&) const;

protected:

  IBool EqualElements    (void const*, void const*) const;

private:

  static
  char const*
           cvClassName;

  Base&    ivBase;

  static
  Base&    BaseOf           (ISortedRelationOnKeySortedBagImpl
                              <Base> const&);

  static
  Ops&     OpsOf            (ISortedRelationOnKeySortedBagImpl
                              <Base> const&);

  friend
  class    ISortedRelationOnKeySortedBagMngCursorImpl <Base>;

#if ! defined (__INO_STREAMING__)
public:
  IStreamerPtr&
           StreamerOf       (IACollectionImpl const&);

  void     StreamIn         (IDataStream&);

  void     StreamOut        (IDataStream&) const;

  void     AdoptStreamer    (IACollectionStreamer*);
#endif
























};

template <class Base>
class IC_EXPORTC IASortedRelationOnKeySortedBagOps {
public:

  virtual ~IASortedRelationOnKeySortedBagOps
                            ();

  virtual
  IACollectionImpl*
           Clone            () const = 0;

  virtual
  IBool EqualElements    (void const*, void const*) const = 0;

  virtual  operator Base&   () = 0;

protected:

private:









};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif





#include <iisrksb.inl>


#pragma info (restore)


#endif // _IISRKSB_
