// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 79 1.4.1.2 source/core/collect/iisstab.c, collection, ioc.v400, 981126 
#ifndef _IISSTAB_C_
#define _IISSTAB_C_


#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)


// ---
// ISortedSetAsTableOps
// ---

// public members

template <class Element, class ElementOps, class Implementation>
ISortedSetAsTableOps <Element, ElementOps, Implementation>::
ISortedSetAsTableOps (INumber numberOfElements)
: ivBase (numberOfElements),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsTableOps <Element, ElementOps, Implementation>::
ISortedSetAsTableOps (INumber numberOfElements, void* opsArg)
: ivBase (numberOfElements, opsArg),
  ivImpl (*this, numberOfElements)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsTableOps <Element, ElementOps, Implementation>::
ISortedSetAsTableOps
  (ISortedSetAsTableOps
    <Element, ElementOps, Implementation> const& collection)
: ivBase (collection.ivBase),
  ivImpl (*this, collection.ivImpl)
{
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsTableOps <Element, ElementOps, Implementation>::
~ISortedSetAsTableOps ()
{
}

template <class Element, class ElementOps, class Implementation>
IACollectionImpl*
ISortedSetAsTableOps <Element, ElementOps, Implementation>::
Clone () const
{ return (Implementation*) *new Self (*this);
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsTableOps <Element, ElementOps, Implementation>::
operator IKeySortedSetAsTableImpl& ()
{ return *(IKeySortedSetAsTableImpl*)ivBase ;
}

template <class Element, class ElementOps, class Implementation>
ISortedSetAsTableOps <Element, ElementOps, Implementation>::
operator Implementation* ()
{ ivImpl.CheckPointer (this);
  return &ivImpl ;
}


#pragma info (restore)


#endif // _IISSTAB_C_
