// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 02 1.6.1.5 source/core/collect/iivkss.h, collection, ioc.v400, trackPseudoLevel 
#ifndef _IIVKSS_
#define _IIVKSS_

#include <ilanglvl.hpp>
#include <iiakss.h>










#pragma info (nocls, nocnd, nocns, nocnv, noext, nognr, novft)


#if __IBMCPP__ >= 400
#pragma namemangling(compat)
#endif

#pragma pack(push,4)
#pragma enum(4)

template <class VInherited>
class IVKeySortedSetImpl : public VInherited {
public:

  typedef TYPENAME VInherited::Ops Ops;

           IVKeySortedSetImpl
                            (Ops&, INumber);

           IVKeySortedSetImpl
                            (Ops&, IVKeySortedSetImpl
                                    <VInherited> const&);

  IBool     Add              (void const*, ICursorImpl&);

  void     AddAllFrom       (IACollectionImpl const&);

  IBool     AddOrReplaceElementWithKey
                            (void const*, ICursorImpl&);

  void     Copy             (IACollectionImpl const&);

  IBool     LocateOrAddElementWithKey
                            (void const*, ICursorImpl&);

  INumber  RemoveAll        ();

  INumber  RemoveAll        (IPredFunc, void*);

  INumber  RemoveAllElementsWithKey
                            (void const*);

  void     RemoveAt         (ICursorImpl&);

  IBool     RemoveElementWithKey
                            (void const*);

  void     RemoveAtPosition (IPosition);

  void     RemoveFirst      ();

  void     RemoveLast       ();

  void     ReplaceAt        (ICursorImpl const&, void const*);

  IBool     ReplaceElementWithKey
                            (void const*, ICursorImpl&);

protected:

private:












};

#pragma enum(pop)
#pragma pack(pop)

#if __IBMCPP__ >= 400
#pragma namemangling()
#endif








#if ! defined (__TEMPINC__)
#include <iivkss.c>
#endif



#pragma info (restore)


#endif // _IIVKSS_
