// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 63 1.4.1.4 source/core/collect/ikssdil.inl, collection, ioc.v400, 981126  
#ifndef _IKSSDIL_INL_
#define _IKSSDIL_INL_

// ---
// IGKeySortedSetAsDilTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class Key, class ElementOps>
inline
IGKeySortedSetAsDilTableCursor <Element, Key, ElementOps>::
IGKeySortedSetAsDilTableCursor
  (IGKeySortedSetAsDilTable
    <Element, Key, ElementOps> const& collection)
: IOrderedCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class Key, class ElementOps>
inline IGKeySortedSetAsDilTableCursor <Element, Key, ElementOps>&
IGKeySortedSetAsDilTableCursor <Element, Key, ElementOps>::
operator=
  (IGKeySortedSetAsDilTableCursor
    <Element, Key, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGKeySortedSetAsDilTableCursor <Element, Key, ElementOps>::
IGKeySortedSetAsDilTableCursor (ICursorImpl* impl)
: IOrderedCursor <Element> (impl)
{
}






























// ---
// IGKeySortedSetAsDilTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGKeySortedSetAsDilTable <Element, Key, ElementOps>::
IGKeySortedSetAsDilTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new




                Instantiation (numberOfElements));
}

template <class Element, class Key, class ElementOps>
inline
IGKeySortedSetAsDilTable <Element, Key, ElementOps>::
IGKeySortedSetAsDilTable
  (IGKeySortedSetAsDilTable
    <Element, Key, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class Key, class ElementOps>
inline IGKeySortedSetAsDilTable <Element, Key, ElementOps>&
IGKeySortedSetAsDilTable <Element, Key, ElementOps>::
operator= (IGKeySortedSetAsDilTable
            <Element, Key, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGKeySortedSetAsDilTable <Element, Key, ElementOps>::
IGKeySortedSetAsDilTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class Key, class ElementOps>
inline TYPENAME IGKeySortedSetAsDilTable
 <Element, Key, ElementOps>::Implementation&
IGKeySortedSetAsDilTable <Element, Key, ElementOps>::
ImplOf (IGKeySortedSetAsDilTable
         <Element, Key, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IKeySortedSetAsDilTable
// ---

// public members

template <class Element, class Key>
inline
IKeySortedSetAsDilTable <Element, Key>::
IKeySortedSetAsDilTable (INumber numberOfElements)
: IGKeySortedSetAsDilTable
   <Element, Key, IKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IKeySortedSetAsDilTable <Element, Key>::
IKeySortedSetAsDilTable (PureImplementation& impl)
: IGKeySortedSetAsDilTable
   <Element, Key, IKCOps <Element, Key> > (impl)
{
}


// ---
// IVGKeySortedSetAsDilTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IVGKeySortedSetAsDilTable <Element, Key, ElementOps>::
IVGKeySortedSetAsDilTable (INumber numberOfElements)
: IGKeySortedSetAsDilTable
    <Element, Key, ElementOps> (*(Implementation*) *new




                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IVGKeySortedSetAsDilTable <Element, Key, ElementOps>::
IVGKeySortedSetAsDilTable (PureImplementation& impl)
: IGKeySortedSetAsDilTable
    <Element, Key, ElementOps> (impl)
{
}

// ---
// IVKeySortedSetAsDilTable
// ---

// public members

template <class Element, class Key>
inline
IVKeySortedSetAsDilTable <Element, Key>::
IVKeySortedSetAsDilTable (INumber numberOfElements)
: IVGKeySortedSetAsDilTable
   <Element, Key, IKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IVKeySortedSetAsDilTable <Element, Key>::
IVKeySortedSetAsDilTable (PureImplementation& impl)
: IVGKeySortedSetAsDilTable
   <Element, Key, IKCOps <Element, Key> > (impl)
{
}


#endif // _IKSSDIL_INL_
