// IBM Open Class Library
//
// Licensed Materials - Property of IBM
//
// (C) Copyright IBM Corporation, 1992, 1997 All Rights Reserved
//
// Revision: 38 1.4.1.4 source/core/collect/ireldil.inl, collection, ioc.v400, 981126  
#ifndef _IRELDIL_INL_
#define _IRELDIL_INL_

// ---
// IGRelationAsDilTableCursor
// ---

#include <ilanglvl.hpp>

// public members

template <class Element, class Key, class ElementOps>
inline
IGRelationAsDilTableCursor <Element, Key, ElementOps>::
IGRelationAsDilTableCursor
  (IGRelationAsDilTable
    <Element, Key, ElementOps> const& collection)
: IElementCursor <Element>
    (collection.ivImpl->CreateCursor ())
{
}

template <class Element, class Key, class ElementOps>
inline IGRelationAsDilTableCursor <Element, Key, ElementOps>&
IGRelationAsDilTableCursor <Element, Key, ElementOps>::
operator=
  (IGRelationAsDilTableCursor
    <Element, Key, ElementOps> const& cursor)
{ Inherited::operator= (cursor);
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGRelationAsDilTableCursor <Element, Key, ElementOps>::
IGRelationAsDilTableCursor (ICursorImpl* impl)
: IElementCursor <Element> (impl)
{
}






























// ---
// IGRelationAsDilTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IGRelationAsDilTable <Element, Key, ElementOps>::
IGRelationAsDilTable (INumber numberOfElements)
{ this->SetImpl ((Implementation*) *new




                Instantiation (numberOfElements));
}

template <class Element, class Key, class ElementOps>
inline
IGRelationAsDilTable <Element, Key, ElementOps>::
IGRelationAsDilTable
  (IGRelationAsDilTable
    <Element, Key, ElementOps> const& collection)
{ this->CloneImplOf (collection);
}

template <class Element, class Key, class ElementOps>
inline IGRelationAsDilTable <Element, Key, ElementOps>&
IGRelationAsDilTable <Element, Key, ElementOps>::
operator= (IGRelationAsDilTable
            <Element, Key, ElementOps> const& collection)
{ this->ImplOf (*this).Copy (this->ImplOf (collection));
  return *this;
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IGRelationAsDilTable <Element, Key, ElementOps>::
IGRelationAsDilTable (PureImplementation& impl)
{ this->SetImpl (&impl);
}

template <class Element, class Key, class ElementOps>
inline TYPENAME IGRelationAsDilTable
 <Element, Key, ElementOps>::Implementation&
IGRelationAsDilTable <Element, Key, ElementOps>::
ImplOf (IGRelationAsDilTable
         <Element, Key, ElementOps> const& collection)
{ return *(Implementation*)collection.ivImpl;
}

// ---
// IRelationAsDilTable
// ---

// public members

template <class Element, class Key>
inline
IRelationAsDilTable <Element, Key>::
IRelationAsDilTable (INumber numberOfElements)
: IGRelationAsDilTable
   <Element, Key, IEKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IRelationAsDilTable <Element, Key>::
IRelationAsDilTable (PureImplementation& impl)
: IGRelationAsDilTable
   <Element, Key, IEKCOps <Element, Key> > (impl)
{
}


// ---
// IVGRelationAsDilTable
// ---

// public members

template <class Element, class Key, class ElementOps>
inline
IVGRelationAsDilTable <Element, Key, ElementOps>::
IVGRelationAsDilTable (INumber numberOfElements)
: IGRelationAsDilTable
    <Element, Key, ElementOps> (*(Implementation*) *new




                Instantiation (numberOfElements))
{
}

// protected members

template <class Element, class Key, class ElementOps>
inline
IVGRelationAsDilTable <Element, Key, ElementOps>::
IVGRelationAsDilTable (PureImplementation& impl)
: IGRelationAsDilTable
    <Element, Key, ElementOps> (impl)
{
}

// ---
// IVRelationAsDilTable
// ---

// public members

template <class Element, class Key>
inline
IVRelationAsDilTable <Element, Key>::
IVRelationAsDilTable (INumber numberOfElements)
: IVGRelationAsDilTable
   <Element, Key, IEKCOps <Element, Key> > (numberOfElements)
{
}

// protected members

template <class Element, class Key>
inline
IVRelationAsDilTable <Element, Key>::
IVRelationAsDilTable (PureImplementation& impl)
: IVGRelationAsDilTable
   <Element, Key, IEKCOps <Element, Key> > (impl)
{
}


#endif // _IRELDIL_INL_
